#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct LastVotedForkSlotsRecord {
    #[prost(uint64, repeated, tag = "1")]
    pub last_voted_fork_slots: ::prost::alloc::vec::Vec<u64>,
    #[prost(string, tag = "2")]
    pub last_vote_bankhash: ::prost::alloc::string::String,
    #[prost(uint32, tag = "3")]
    pub shred_version: u32,
    #[prost(uint64, tag = "4")]
    pub wallclock: u64,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct LastVotedForkSlotsAggregateRecord {
    #[prost(map = "string, message", tag = "1")]
    pub received: ::std::collections::HashMap<
        ::prost::alloc::string::String,
        LastVotedForkSlotsRecord,
    >,
    #[prost(message, optional, tag = "2")]
    pub final_result: ::core::option::Option<LastVotedForkSlotsAggregateFinal>,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct LastVotedForkSlotsEpochInfoRecord {
    #[prost(uint64, tag = "1")]
    pub epoch: u64,
    #[prost(uint64, tag = "2")]
    pub total_stake: u64,
    #[prost(uint64, tag = "3")]
    pub actively_voting_stake: u64,
    #[prost(uint64, tag = "4")]
    pub actively_voting_for_this_epoch_stake: u64,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct LastVotedForkSlotsAggregateFinal {
    #[prost(map = "uint64, uint64", tag = "1")]
    pub slots_stake_map: ::std::collections::HashMap<u64, u64>,
    #[prost(message, repeated, tag = "2")]
    pub epoch_infos: ::prost::alloc::vec::Vec<LastVotedForkSlotsEpochInfoRecord>,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct HeaviestForkRecord {
    #[prost(uint64, tag = "1")]
    pub slot: u64,
    #[prost(string, tag = "2")]
    pub bankhash: ::prost::alloc::string::String,
    #[prost(uint64, tag = "3")]
    pub total_active_stake: u64,
    #[prost(uint32, tag = "4")]
    pub shred_version: u32,
    #[prost(uint64, tag = "5")]
    pub wallclock: u64,
    #[prost(string, tag = "6")]
    pub from: ::prost::alloc::string::String,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct HeaviestForkAggregateRecord {
    #[prost(message, repeated, tag = "1")]
    pub received: ::prost::alloc::vec::Vec<HeaviestForkRecord>,
    #[prost(uint64, tag = "2")]
    pub total_active_stake: u64,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct GenerateSnapshotRecord {
    #[prost(string, tag = "1")]
    pub path: ::prost::alloc::string::String,
    #[prost(uint64, tag = "2")]
    pub slot: u64,
    #[prost(string, tag = "3")]
    pub bankhash: ::prost::alloc::string::String,
    #[prost(uint32, tag = "4")]
    pub shred_version: u32,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct ConflictMessage {
    #[prost(string, tag = "2")]
    pub old_message: ::prost::alloc::string::String,
    #[prost(string, tag = "3")]
    pub new_message: ::prost::alloc::string::String,
}
#[allow(clippy::derive_partial_eq_without_eq)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct WenRestartProgress {
    #[prost(enumeration = "State", tag = "1")]
    pub state: i32,
    #[prost(message, optional, tag = "2")]
    pub my_last_voted_fork_slots: ::core::option::Option<LastVotedForkSlotsRecord>,
    #[prost(message, optional, tag = "3")]
    pub last_voted_fork_slots_aggregate: ::core::option::Option<
        LastVotedForkSlotsAggregateRecord,
    >,
    #[prost(message, optional, tag = "4")]
    pub my_heaviest_fork: ::core::option::Option<HeaviestForkRecord>,
    #[prost(message, optional, tag = "5")]
    pub heaviest_fork_aggregate: ::core::option::Option<HeaviestForkAggregateRecord>,
    #[prost(message, optional, tag = "6")]
    pub coordinator_heaviest_fork: ::core::option::Option<HeaviestForkRecord>,
    #[prost(message, optional, tag = "7")]
    pub my_snapshot: ::core::option::Option<GenerateSnapshotRecord>,
    #[prost(map = "string, message", tag = "8")]
    pub conflict_message: ::std::collections::HashMap<
        ::prost::alloc::string::String,
        ConflictMessage,
    >,
}
#[derive(Clone, Copy, Debug, PartialEq, Eq, Hash, PartialOrd, Ord, ::prost::Enumeration)]
#[repr(i32)]
pub enum State {
    Init = 0,
    LastVotedForkSlots = 1,
    HeaviestFork = 2,
    GenerateSnapshot = 3,
    Done = 4,
}
impl State {
    /// String value of the enum field names used in the ProtoBuf definition.
    ///
    /// The values are not transformed in any way and thus are considered stable
    /// (if the ProtoBuf definition does not change) and safe for programmatic use.
    pub fn as_str_name(&self) -> &'static str {
        match self {
            State::Init => "INIT",
            State::LastVotedForkSlots => "LAST_VOTED_FORK_SLOTS",
            State::HeaviestFork => "HEAVIEST_FORK",
            State::GenerateSnapshot => "GENERATE_SNAPSHOT",
            State::Done => "DONE",
        }
    }
    /// Creates an enum from field names used in the ProtoBuf definition.
    pub fn from_str_name(value: &str) -> ::core::option::Option<Self> {
        match value {
            "INIT" => Some(Self::Init),
            "LAST_VOTED_FORK_SLOTS" => Some(Self::LastVotedForkSlots),
            "HEAVIEST_FORK" => Some(Self::HeaviestFork),
            "GENERATE_SNAPSHOT" => Some(Self::GenerateSnapshot),
            "DONE" => Some(Self::Done),
            _ => None,
        }
    }
}
